
var snipasteController = JSB.defineClass('snipasteController : UIViewController', {
  viewDidLoad: function() {
    self.homeImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/home.png`), 2)
    self.gobackImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/goback.png`), 2)
    self.goforwardImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/goforward.png`), 2)
    self.screenImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/screen.png`), 2)
    self.snipasteImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/snipaste.png`), 2)
    self.custom = false;
    self.customMode = "None"
    self.dynamic = true;
    self.miniMode = false;
    self.isLoading = false;
    self.lastFrame = self.view.frame;
    self.currentFrame = self.view.frame
    self.view.layer.shadowOffset = {width: 0, height: 0};
    self.view.layer.shadowRadius = 15;
    self.view.layer.shadowOpacity = 0.5;
    self.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
    self.view.layer.opacity = 1.0
    // >>> DeepL view >>>
    self.webview = new UIWebView(self.view.bounds);
    // NSUserDefaults.standardUserDefaults().setObjectForKey('Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15',"UserAgent")

    //  Application.sharedInstance().showHUD("error", self.view.window, 2);
    self.webview.backgroundColor = UIColor.whiteColor();
    self.webview.scalesPageToFit = true;
    self.webview.autoresizingMask = (1 << 1 | 1 << 4);
    self.webview.delegate = self;
    // self.webview.setValueForKey("Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15","User-Agent")
    self.webview.scrollView.delegate = self;
    self.webview.layer.cornerRadius = 15;
    self.webview.layer.masksToBounds = true;
    self.highlightColor = UIColor.blendedColor(
      UIColor.colorWithHexString("#2c4d81").colorWithAlphaComponent(0.8),
      Application.sharedInstance().defaultTextColor,
      0.8
    );
    // >>> DeepL langauge button >>>
    // self.webview.lanButton = UIButton.buttonWithType(0);
    // <<< DeepL langauge button <<<
    self.webview.hidden = true;
    self.webview.lastOffset = 0;
    self.view.addSubview(self.webview);
    // <<< DeepL view <<<

// >>> opacity button >>>
    // self.webAppButton.titleLabel.font = UIFont.systemFontOfSize(12);
    // <<< opacity button <<<
    // >>> close button >>>
    self.closeButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.closeButton,"closeButtonTapped:")
    self.closeButton.setTitleForState('✖️', 0);
    self.closeButton.titleLabel.font = UIFont.systemFontOfSize(10);
    // <<< close button <<<
    // >>> max button >>>
    self.maxButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.maxButton,"maxButtonTapped:")
    self.maxButton.setTitleForState('➕', 0);
    self.maxButton.titleLabel.font = UIFont.systemFontOfSize(10);
    // <<< max button <<<
    // >>> screen button >>>
    self.screenButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.screenButton,"changeScreen:")
    self.screenButton.setImageForState(self.screenImage,0)
    // <<< screen button <<<
    // >>> search button >>>
    self.searchButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.searchButton,"searchButtonTapped:")
    self.searchButton.setImageForState(self.snipasteImage,0)

    // self.searchButton.setTitleForState('🔍', 0);
    // <<< search button <<<
    // >>> move button >>>
    self.moveButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.moveButton)
    // <<< move button <<<
    // >>> goForward button >>>
    self.goForwardButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.goForwardButton,"goForwardButtonTapped:")
    self.goForwardButton.setImageForState(self.goforwardImage,0)
    // <<< goForward button <<<
      // >>> goBack button >>>
    self.goBackButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.goBackButton,"goBackButtonTapped:")
    self.goBackButton.setImageForState(self.gobackImage,0)
    // <<< goBack button <<<

    self.moveGesture = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.moveButton.addGestureRecognizer(self.moveGesture)
    self.moveGesture.view.hidden = false
    self.moveGesture.addTargetAction(self,"onMoveGesture:")

    self.resizeGesture = new UIPanGestureRecognizer(self,"onResizeGesture:")
    self.screenButton.addGestureRecognizer(self.resizeGesture)
    self.resizeGesture.view.hidden = false
    self.resizeGesture.addTargetAction(self,"onResizeGesture:")
  },
  viewWillAppear: function(animated) {
    self.webview.delegate = self;
  },
  viewWillDisappear: function(animated) {
    self.webview.stopLoading();
    self.webview.delegate = null;
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
  },
viewWillLayoutSubviews: function() {
    // Application.sharedInstance().showHUD("test", self.view.window, 2);

    if (self.miniMode) {
      // self.webview.hidden = true
      return
    }

    var viewFrame = self.view.bounds;
    var xLeft     = viewFrame.x
    var xRight    = xLeft + viewFrame.width
    var yTop      = viewFrame.y
    var yBottom   = yTop + viewFrame.height
    self.closeButton.frame = {x: xRight-18,y: yTop,width: 18,height: 18};
    self.maxButton.frame   = {x: xRight-43,y: yTop,width: 18,height: 18};
    self.screenButton.frame = {x: xRight - 37,y: yBottom - 30,width: 30,height: 25};
    self.moveButton.frame = {  x: xRight*0.5-75,  y: yTop,  width: 150,  height: 12,};
    self.searchButton.frame = {  x: xRight - 72,  y: yBottom - 30,  width: 30,  height: 25,}
    self.goBackButton.frame = {  x: xLeft+6,  y: yBottom - 30,  width: 30,  height: 25,};
    self.goForwardButton.frame = {  x: xLeft+41,  y: yBottom - 30,  width: 30,  height: 25,};
    self.webview.frame = {x:xLeft+1,y:yTop+6,width:viewFrame.width-2,height:viewFrame.height-6}
  },
  scrollViewDidScroll: function() {
  },
  webViewDidStartLoad: function(webView) {
  },
  webViewDidFinishLoad: function(webView) {
    if (webView.canGoBack) {
      self.goBackButton.layer.opacity = 1.0
    }else{
      self.goBackButton.layer.opacity = 0.5
    }
    if (webView.canGoForward) {
      self.goForwardButton.layer.opacity = 1.0
    }else{
      self.goForwardButton.layer.opacity = 0.5
    }
  },
  webViewDidFailLoadWithError: function(webView, error) {
  },

  changeScreen: function(sender) {
    //  Application.sharedInstance().showHUD(self.appearOnNewExcerpt, self.view.window, 2);
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();

    menuController.commandTable = [
      {title:'🌗 Left',object:self,selector:'leftButtonTapped:',param:'left',checked:self.customMode==="left"},
      {title:'🌘 Left 1/3',object:self,selector:'left13ButtonTapped:',param:'left',checked:self.customMode==="left13"},
      {title:'🌓 Right',object:self,selector:'rightButtonTapped:',param:'right',checked:self.customMode==="right"},
      {title:'🌒 Right 1/3',object:self,selector:'right13ButtonTapped:',param:'right',checked:self.customMode==="right13"},
      {title:'🫧 Opacity',object:self,selector:'changeOpacity:',param:sender},
    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 250,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeOpacity: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    menuController.commandTable = [
      {title:'100%',object:self,selector:'changeOpacityTo:',param:1.0},
      {title:'90%',object:self,selector:'changeOpacityTo:',param:0.9},
      {title:'80%',object:self,selector:'changeOpacityTo:',param:0.8},
      {title:'70%',object:self,selector:'changeOpacityTo:',param:0.7},
      {title:'60%',object:self,selector:'changeOpacityTo:',param:0.6},
      {title:'50%',object:self,selector:'changeOpacityTo:',param:0.5}
    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 100,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeOpacityTo:function (opacity) {
    self.view.layer.opacity = opacity
    // self.webAppButton.setTitleForState(`${opacity*100}%`, 0);
  },
  searchButtonTapped: function() {
      // Application.sharedInstance().showHUD("width: "+imageSize.width+" hiehgt: "+imageSize.height, self.window, 2)
    let docMapSplitMode = Application.sharedInstance().studyController(self.view.window).docMapSplitMode
    let wholeFrame = Application.sharedInstance().studyController(self.view.window).view.bounds
    let imageData = Application.sharedInstance().studyController(self.view.window).readerController.documentControllers[0].imageFromSelection()
    if (!imageData) {
      imageData = Application.sharedInstance().studyController(self.view.window).readerController.documentControllers[0].imageFromFocusNote()
    }
    if (!imageData || docMapSplitMode===0) {
      let focusNote = Application.sharedInstance().studyController(self.view.window).notebookController.focusNote
      if (focusNote && focusNote.excerptPic) {
        imageData = Database.sharedInstance().getMediaByHash(focusNote.excerptPic.paint)
      }else{
        imageData = undefined
      }
    }
    if (imageData) {
      let image = UIImage.imageWithData(imageData)
      // let rotateImage = UIImage.imageWithCGImageScaleOrientation(image.CGImage,1,2)
      // let rotateImageData = rotateImage.pngData
      let imageSize = image.size
      let widthScale = wholeFrame.width/imageSize.width*0.5
      let heightScale = wholeFrame.height/imageSize.height*0.5
      let scale = Math.min(widthScale,heightScale)
      if (scale > 1) {
        scale = 1
      }
      // let scale = (imageSize.width < 600 || imageSize.height < 200)?1.0:0.5
      // Application.sharedInstance().showHUD("width: "+imageSize.width+" hiehgt: "+imageSize.height, self.window, 2)
      let viewFrame = self.view.frame
      self.view.frame = {x:viewFrame.x,y:viewFrame.y,width:imageSize.width*scale,height:imageSize.height*scale}
      self.currentFrame = {x:viewFrame.x,y:viewFrame.y,width:imageSize.width*scale,height:imageSize.height*scale}
    // style="transform:rotate(7deg)"
    self.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(`data:image/jpeg;base64,${imageData.base64Encoding()}`)))
      // self.webview.loadHTMLStringBaseURL(`
      // <img width="100%" src="data:image/jpeg;base64,${image.base64Encoding()}"/>`)
      self.view.hidden = false
      self.webview.hidden = false
    }else{
      Application.sharedInstance().showHUD("No image selected", self.view.window, 2)
    }
  },
  goBackButtonTapped: function() {
    self.webview.goBack();
  },
  goForwardButtonTapped: function() {
    self.webview.goForward();
  },
  closeButtonTapped: function() {
    self.view.hidden = true;
    },
  leftButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // self.view.popoverController.dismissPopoverAnimated(true);
    self.lastFrame = self.view.frame
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    // Application.sharedInstance().showHUD(splitLine,self.view.window,2)
    self.view.frame = {x:40,y:50,width:splitLine-40,height:height-50}
    self.custom = true;
    self.customMode = "left"
    self.dynamic = false;
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  left13ButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.customMode = "left13"
    self.dynamic = false;
    self.lastFrame = self.view.frame

    // self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    // Application.sharedInstance().showHUD(splitLine,self.view.window,2)
    self.view.frame = {x:40,y:60,width:studyFrame.width/3.+40,height:height-60}
    self.custom = true;
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  rightButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.customMode = "right"
    self.dynamic = false;
    self.lastFrame = self.view.frame
    // self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    self.view.frame = {x:splitLine,y:50,width:studyFrame.width-splitLine-40,height:height-50}
    self.custom = true;
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  right13ButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.custom = true;
    self.customMode = "right13"
    self.dynamic = false;
    self.lastFrame = self.view.frame
    // self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    self.view.frame = {x:splitLine,y:50,width:studyFrame.width-splitLine-40,height:height-50}
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  maxButtonTapped: function() {
    if (self.customMode === "full") {
      self.customMode = "none"
      self.custom = false;
      self.view.frame = self.lastFrame
      return
    }
    const frame = Application.sharedInstance().studyController(this.window).view.bounds
    self.lastFrame = self.view.frame
    self.view.frame = {x:40,y:50,width:frame.width-80,height:frame.height-70}
    self.customMode = "full"
    self.custom = true;
    self.dynamic = false;
    self.webview.hidden = false
  },
  onMoveGesture:function (gesture) {
    self.dynamic = false;
    let baseframe = gesture.view.frame
    let locationInView = gesture.locationInView(gesture.view)
    let translationX = locationInView.x - baseframe.width*0.5
    let translationY = locationInView.y - baseframe.height*0.5
    let frame = self.view.frame
    var viewFrame = self.view.bounds;
    let studyFrame = Application.sharedInstance().studyController(self.view.window).view.bounds
    let y = frame.y+translationY
    if (y<=0) {
      y = 0
    }
    if (y>=studyFrame.height-15) {
      y = studyFrame.height-15
    }
    let x = frame.x+translationX
    if (!self.miniMode) {
      if (x+frame.width*0.5-40<0) {
        self.miniMode = true 
        self.dynamic = false    
        self.lastFrame = frame 
        self.webview.hidden = true
        self.view.frame = {
          x:0,
          y:frame.y,
          width:40,
          height:40
        }
        self.currentFrame  = self.view.frame
        self.closeButton.hidden = true
        self.maxButton.hidden = true
        self.screenButton.hidden = true
        self.moveButton.frame = {
          x: -10,
          y: 0,
          width: 50,
          height: 40,
        };
        return
      }
      if (x>studyFrame.width-frame.width*0.5-40) {
        x=studyFrame.width-frame.width*0.5-40
        self.miniMode = true     
        self.dynamic = false    
        self.lastFrame = frame 
        self.webview.hidden = true
        self.view.frame = {
          x:studyFrame.width-40,
          y:frame.y,
          width:40,
          height:40
        }
        self.currentFrame  = self.view.frame
        self.closeButton.hidden = true
        self.maxButton.hidden = true
        self.screenButton.hidden = true
        self.goBackButton.hidden = true
        self.goForwardButton.hidden = true
        self.searchButton.hidden = true
        self.moveButton.frame = {
          x: 0,
          y: 0,
          width: 50,
          height: 40,
        };
        return
      }
    }else{
      if (x+frame.width*0.5-50<=0) {
        x = -frame.width*0.5+20
      }else if (x>studyFrame.width-frame.width*0.5-50) {
        x = studyFrame.width-40
      }else{
        self.view.frame = {
          x:40,
          y:y,
          width:self.lastFrame.width,
          height:self.lastFrame.height
        }
        self.currentFrame  = self.view.frame
        viewFrame = self.view.bounds;
        self.miniMode = false
        self.moveButton.frame = {
          x: viewFrame.x + viewFrame.width*0.5-75,
          y: viewFrame.y + 5,
          width: 150,
          height: 10,
        };
        self.webview.hidden = false
        self.closeButton.hidden = false
        self.maxButton.hidden = false
        self.screenButton.hidden = false
        self.searchButton.hidden = false
        return
      }
    }
    
    if (self.custom) {
      // Application.sharedInstance().showHUD(self.custom, self.view.window, 2);
      self.customMode = "None"
      self.view.frame = {x:x,y:y,width:self.lastFrame.width,height:self.lastFrame.height}
      self.currentFrame  = self.view.frame

    }else{
      self.view.frame = {x:x,y:y,width:frame.width,height:frame.height}
      self.currentFrame  = self.view.frame

    }
    self.custom = false;
  },
  onResizeGesture:function (gesture) {
    self.custom = false;
    self.dynamic = false;
    let baseframe = gesture.view.frame
    let locationInView = gesture.locationInView(gesture.view)
    let frame = self.view.frame
    let width = locationInView.x+baseframe.x+baseframe.width*0.5
    let height = locationInView.y+baseframe.y+baseframe.height*0.5
    if (width <= 200) {
      width = 200
    }
    if (height <= 100) {
      height = 100
    }
    //  Application.sharedInstance().showHUD(`{x:${translation.x},y:${translation.y}}`, self.view.window, 2);
    //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
    self.view.frame = {x:frame.x,y:frame.y,width:width,height:height}
    self.currentFrame  = self.view.frame
  },
});
snipasteController.prototype.setButtonLayout = function (button,targetAction) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.whiteColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
    button.layer.cornerRadius = 10;
    button.layer.masksToBounds = true;
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.view.addSubview(button);
}
function getSplitLine() {
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let readerFrame = Application.sharedInstance().studyController(this.window).readerController.view.frame
    let hidden = Application.sharedInstance().studyController(this.window).readerController.view.hidden//true代表脑图全屏
    let rightMode = Application.sharedInstance().studyController(this.window).rightMapMode
    let fullWindow = readerFrame.width == studyFrame.width
    if (hidden || fullWindow) {
      let splitLine = studyFrame.width*0.5
      return splitLine
    }
    if (rightMode) {
      let splitLine = readerFrame.x+readerFrame.width
      return splitLine
    }else{
      let splitLine = readerFrame.x
      return splitLine
    }
  }